﻿SLASH_INTERRUPTMANAGER1 = '/im'

function InterruptManager_OnLoad()
    for i = 1,5 do 
        if not getglobal("IMBarIcon"..i) then
            local f = CreateFrame("Frame","IMBarIcon"..i)
            f:SetHeight(20)
            f:SetWidth(20)
            f:SetPoint("CENTER",UIParent,"CENTER",200,-200-i*20)
            local a = f:CreateTexture()
            a:SetAllPoints(f)
            a:SetTexture(0,0,0,0.5)
            local t = f:CreateFontString()
            t:SetPoint("CENTER","IMBarIcon"..i,"CENTER",0,0)
            t:SetFont("Fonts\\FRIZQT__.TTF", 16)
            t:SetText(i)
            
            local f = CreateFrame("Frame","IMBarTexture"..i)
            f:SetHeight(20)
            f:SetWidth(180)
            f:SetPoint("LEFT","IMBarIcon"..i,"RIGHT")
            local a = f:CreateTexture()
            a:SetAllPoints(f)
            a:SetTexture(0,0,0,0.4)
            
            local f = CreateFrame("Frame")
            f:SetHeight(20)
            f:SetWidth(180)
            f:SetPoint("LEFT","IMBarIcon"..i,"RIGHT")
            f:SetFrameLevel(3)
            local t = f:CreateFontString("IMBarText"..i)
            t:SetPoint("LEFT",f,"LEFT",3,0)
            t:SetFont("Fonts\\FRIZQT__.TTF", 12)
            
            local f = CreateFrame("StatusBar","IMBar"..i)
            f:SetFrameStrata("MEDIUM")
            f:SetHeight(20)
            f:SetWidth(180)
            f:SetPoint("LEFT","IMBarIcon"..i,"RIGHT")
            f:SetOrientation("HORIZONTAL")
            f:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
            f:SetMinMaxValues(0,5)
            f:SetValue(0)
            f:SetStatusBarColor(0,1,0)
            f:SetFrameLevel(2)
        end
    end
    InterruptManager:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
    InterruptManager:RegisterEvent("CHAT_MSG_ADDON")
    InterruptManager:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START")
    InterruptManager:RegisterEvent("UNIT_SPELLCAST_START")
    InterruptManager:RegisterEvent("UNIT_DIED")
    InterruptManager:RegisterEvent("PLAYER_REGEN_DISABLED")
    InterruptManager:RegisterEvent("PLAYER_REGEN_ENABLED")
    SendAddonMessage("InterruptM","Remind","RAID")
end

local c = CreateFrame("MessageFrame","InterruptManagerText")
c:SetWidth(300)
c:SetHeight(30)
c:SetPoint("CENTER", UIParent, "CENTER", 0, 80)
c:SetFont("Fonts\\FRIZQT__.TTF", 25)
c:SetFadeDuration(1)
c:SetTimeVisible(2)

local CPUSafe = GetTime()
local leader
local interrupters = {IM1,IM2,IM3,IM4,IM5}
local cooldowns1 = {}
local cooldowns2 = {}
local lastExpirant
local version = 1.12
local playStyle = 1 --[ 1=PvE, 2=PvP ]--
local PUGMode = 0
local announce = 1
local focusMode = "target"
local soloMode = 0
local registeredUsers = {}
local interruptSpells = {96231, 80964, 80965, 78675, 47528, 47476, 2139, 1766, 51680, 34490, 57994, 19647, 26090, 6552, 15487, 72}
local cooldown
local spells45 = {72}
local spells24 = {2139, 26090}
local spells20 = {34490}
local spells10 = {96231, 80964, 80965, 47528, 1766, 15487}
local spells6 = {57994}

function InterruptManager_OnEvent(self, event, ...)
    if event == "COMBAT_LOG_EVENT_UNFILTERED" then
        local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags = select(1, ...)
        if type == "UNIT_DIED" then
            if tContains(interrupters,destName) then
                tremove(interrupters,destName)
            end
        end
        if (type == "SPELL_CAST_SUCCESS") then
            local spellID, spellName, spellSchool = select(10, ...)
            if tContains(interruptSpells, spellID) then
                if tContains(spells45,spellID) then
                    cooldown = 45
                    elseif tContains(spells24,spellID) then
                    cooldown = 24
                    elseif tContains(spells20,spellID) then
                    cooldown = 20
                    elseif tContains(spells10,spellID) then
                    cooldown = 10
                    elseif tContains(spells6,spellID) then
                    cooldown = 6
                end
                if sourceName == GetUnitName("player") then
                    if announce == 1 then
                        SendChatMessage("Used "..spellName)
                    end
                end
                if tContains(interrupters, sourceName) then
                    if #interrupters == 1 then
                        interrupters[1] = sourceName
                        IMBarText1:SetText(sourceName)
                    end
                    if #interrupters == 2 then
                        if interrupters[1] == sourceName then
                            interrupters[1] = interrupters[2]
                            IMBarText1:SetText(interrupters[2])
                            cooldowns1[1] = cooldowns1[2] cooldowns2[1] = cooldowns2[2]
                        end
                        interrupters[2] = sourceName
                        IMBarText2:SetText(sourceName)
                        CD(cooldown,2)
                    end
                    if #interrupters == 3 then
                        if interrupters[1] == sourceName then
                            interrupters[1] = interrupters[2]
                            interrupters[2] = interrupters[3]
                            IMBarText1:SetText(IMBarText2:GetText())
                            IMBarText2:SetText(IMBarText3:GetText())
                            cooldowns1[1] = cooldowns1[2] cooldowns2[1] = cooldowns2[2]
                            cooldowns1[2] = cooldowns1[3] cooldowns2[2] = cooldowns2[3]
                            elseif
                            interrupters[2] == sourceName then
                            interrupters[2] = interrupters[3]
                            cooldowns1[2] = cooldowns1[3] cooldowns2[2] = cooldowns2[3]
                            IMBarText2:SetText(IMBarText3:GetText())
                        end
                        interrupters[3] = sourceName
                        IMBarText3:SetText(sourceName)
                        CD(cooldown,3)
                    end
                    if #interrupters == 4 then
                        if interrupters[1] == sourceName then
                            interrupters[1] = interrupters[2]
                            interrupters[2] = interrupters[3]
                            interrupters[3] = interrupters[4]
                            cooldowns1[1] = cooldowns1[2] cooldowns2[1] = cooldowns2[2]
                            cooldowns1[2] = cooldowns1[3] cooldowns2[2] = cooldowns2[3]
                            cooldowns1[3] = cooldowns1[4] cooldowns2[3] = cooldowns2[4]
                            IMBarText1:SetText(IMBarText2:GetText())
                            IMBarText2:SetText(IMBarText3:GetText())
                            IMBarText3:SetText(IMBarText4:GetText())
                            elseif interrupters[2] == sourceName then
                            interrupters[2] = interrupters[3]
                            interrupters[3] = interrupters[4]
                            cooldowns1[2] = cooldowns1[3] cooldowns2[2] = cooldowns2[3]
                            cooldowns1[3] = cooldowns1[4] cooldowns2[3] = cooldowns2[4]
                            IMBarText2:SetText(IMBarText3:GetText())
                            IMBarText3:SetText(IMBarText4:GetText())
                            elseif interrupters[3] == sourceName then
                            interrupters[3] = interrupters[4]
                            cooldowns1[3] = cooldowns1[4] cooldowns2[3] = cooldowns2[4]
                            IMBarText3:SetText(IMBarText4:GetText())
                        end
                        interrupters[4] = sourceName
                        IMBarText4:SetText(sourceName)
                        CD(cooldown,4)
                    end
                    if #interrupters == 5 then
                        if interrupters[1] == sourceName then
                            interrupters[1] = interrupters[2]
                            interrupters[2] = interrupters[3]
                            interrupters[3] = interrupters[4]
                            interrupters[4] = interrupters[5]
                            cooldowns1[1] = cooldowns1[2] cooldowns2[1] = cooldowns2[2]
                            cooldowns1[2] = cooldowns1[3] cooldowns2[2] = cooldowns2[3]
                            cooldowns1[3] = cooldowns1[4] cooldowns2[3] = cooldowns2[4]
                            cooldowns1[4] = cooldowns1[5] cooldowns2[4] = cooldowns2[5]
                            IMBarText1:SetText(IMBarText2:GetText())
                            IMBarText2:SetText(IMBarText3:GetText())
                            IMBarText3:SetText(IMBarText4:GetText())
                            IMBarText4:SetText(IMBarText5:GetText())
                            elseif interrupters[2] == sourceName then
                            interrupters[2] = interrupters[3]
                            interrupters[3] = interrupters[4]
                            interrupters[4] = interrupters[5]
                            cooldowns1[2] = cooldowns1[3] cooldowns2[2] = cooldowns2[3]
                            cooldowns1[3] = cooldowns1[4] cooldowns2[3] = cooldowns2[4]
                            cooldowns1[4] = cooldowns1[5] cooldowns2[4] = cooldowns2[5]
                            IMBarText2:SetText(IMBarText3:GetText())
                            IMBarText3:SetText(IMBarText4:GetText())
                            IMBarText4:SetText(IMBarText5:GetText())
                            elseif interrupters[3] == sourceName then
                            interrupters[3] = interrupters[4]
                            interrupters[4] = interrupters[5]
                            cooldowns1[3] = cooldowns1[4] cooldowns2[3] = cooldowns2[4]
                            cooldowns1[4] = cooldowns1[5] cooldowns2[4] = cooldowns2[5]
                            IMBarText3:SetText(IMBarText4:GetText())
                            IMBarText4:SetText(IMBarText5:GetText())
                            elseif interrupters[4] == sourceName then
                            interrupters[4] = interrupters[5]
                            cooldowns1[4] = cooldowns1[5] cooldowns2[4] = cooldowns2[5]
                            IMBarText4:SetText(IMBarText5:GetText())
                        end
                        interrupters[5] = sourceName
                        IMBarText5:SetText(sourceName)
                        CD(cooldown,5)
                    end
                    if PUGMode == 1 and leader == UnitName("player") then
                        if GetNumRaidMembers() > 0 then
                            SendChatMessage("Interrupting next: "..interrupters[1],"RAID")
                            elseif GetNumPartyMembers() > 0 then
                            SendChatMessage("Interrupting next: "..interrupters[1],"PARTY")
                        end
                    end
                    if interrupters[1] == UnitName("player") then
                        InterruptManagerText:AddMessage("You are interrupting next!",0,1,0)
                        PlaySoundFile("Sound\\Interface\\PVPFlagCapturedHordeMono.wav")
                    end
                end
            end
        end
        elseif event == "PLAYER_REGEN_ENABLED_HAAAAAAAAAAASD" and playStyle == 1 then
            IMUpdateInterrupters()
        elseif event == "CHAT_MSG_ADDON" then
        local prefix, msg,_,sender = select(1,...)
        if prefix == "InterruptM" and msg == "leader" then
            leader = sender
        end
        if prefix == "InterruptM" and msg == "Remind" and sender ~= UnitName("player") then
            IMRemind()
        end
        if prefix == "InterruptManager" then
            if sender ~= UnitName("target") and not tContains(registeredUsers,sender) and tContains(interrupters,sender) then
                print("InterruptManager: Received addon response from "..sender)
                tinsert(registeredUsers,sender)
            end
        end
        if string.find(prefix,"IM") and msg then
            SendAddonMessage("InterruptManager",version,"RAID")
        end
        if sender ~= UnitName("player") then
            if prefix == "IM1" and msg and msg ~= "" then
                IMBarText1:SetText(msg)
                IMConfigEditbox1:SetText(msg)
                interrupters[1] = msg
                elseif prefix == "IM2" and msg and msg ~= "" then
                IMBarText2:SetText(msg)
                IMConfigEditbox2:SetText(msg)
                interrupters[2] = msg
                elseif prefix == "IM3" and msg and msg ~= "" then
                IMBarText3:SetText(msg)
                IMConfigEditbox3:SetText(msg)
                interrupters[3] = msg
                elseif prefix == "IM4" and msg and msg ~= "" then
                IMBarText4:SetText(msg)
                IMConfigEditbox4:SetText(msg)
                interrupters[4] = msg
                elseif prefix == "IM5" and msg and msg ~= "" then
                IMBarText5:SetText(msg)
                IMConfigEditbox5:SetText(msg)
                interrupters[5] = msg
            end
        end
        elseif event == "UNIT_SPELLCAST_START" or event == "UNIT_SPELLCAST_CHANNEL_START" then
        local caster,_,_,_,spellID = select(1,...)
        wipe(registeredUsers)
        if caster == focusMode and (interrupters[1] == UnitName("player") or soloMode == 1) then
            local _, _, _, _, _, _, _, _, i = UnitCastingInfo(focusMode)
                if not i then
                PlaySoundFile("Sound\\Interface\\PVPFlagTakenMono.wav")
                InterruptManagerText:AddMessage("Interrupt!",0,0,1)
            end
        end
        elseif event == "PLAYER_REGEN_DISABLED" then
        if #interrupters == #registeredUsers then
            ChatFrame1:AddMessage("All interrupters have InterruptManager enabled.",0,1,0)
            PUGMode = 0
            else
            ChatFrame1:AddMessage("Warning: Not all interrupters have InterruptManager enabled. Going PUG mode.",1,0.1,0)
            PUGMode = 1
        end
    end
end

function SlashCmdList.INTERRUPTMANAGER(msg, editbox)
    IMConfigFrame:Show()
end

function IMAnnounceToggle()
    if announce == 1 then
        announce = 0
        IMConfigAnnounceToggleButton:SetText("Enable Announce")
        ChatFrame1:AddMessage("InterruptManager: Announce is now disabled.",1,0.5,0)
    else
        announce = 1
        IMConfigAnnounceToggleButton:SetText("Disable Announce")
        ChatFrame1:AddMessage("InterruptManager: Announce is now enabled.",1,0.5,0)
    end
end

function IMFocusModeToggle()
    if focusMode == "target" then
        focusMode = "focus"
        IMConfigFocusToggleButton:SetText("Disable Focus Mode")
        ChatFrame1:AddMessage("InterruptManager: Focus mode is now enabled. Will now only warn when your focus is casting a spell.",1,0.5,0)
        else
        focusMode = "target"
        IMConfigFocusToggleButton:SetText("Enable Focus Mode")
        ChatFrame1:AddMessage("InterruptManager: Focus mode is now disabled.",1,0.5,0)
    end
end

function IMSoloModeToggle()
    if soloMode == 0 then
        soloMode = 1
        IMConfigSoloToggleButton:SetText("Disable Solo Mode")
        ChatFrame1:AddMessage("InterruptManager: Solo mode is now enabled. Will now warn if a spell is being cast by your target/focus regardless of your position in the queue.",1,0.5,0)
        else
        soloMode = 0
        IMConfigSoloToggleButton:SetText("Enable Solo Mode")
        ChatFrame1:AddMessage("InterruptManager: Solo mode is now disabled.",1,0.5,0)
    end
end

function IMRemind()
    if leader == UnitName("player") then
        SendAddonMessage("IM1",interrupters[1],"RAID")
        SendAddonMessage("IM2",interrupters[2],"RAID")
        SendAddonMessage("IM3",interrupters[3],"RAID")
        SendAddonMessage("IM4",interrupters[4],"RAID")
        SendAddonMessage("IM5",interrupters[5],"RAID")
    end
end

function IMUpdateInterrupters()
    wipe(interrupters)
    for i=1,5 do
        if getglobal("IMConfigEditbox"..i):GetText() ~= "" and not strfind(getglobal("IMConfigEditbox"..i):GetText()," interrupter") then
            interrupters[i] = getglobal("IMConfigEditbox"..i):GetText()
        end
    end
    for i = 1,5 do
        getglobal("IMBarText"..i):SetText("")
        getglobal("IMBarText"..i):SetText(interrupters[i])
    end
    SendAddonMessage("InterruptM","leader","RAID")
    SendAddonMessage("IM1",interrupters[1],"RAID")
    SendAddonMessage("IM2",interrupters[2],"RAID")
    SendAddonMessage("IM3",interrupters[3],"RAID")
    SendAddonMessage("IM4",interrupters[4],"RAID")
    SendAddonMessage("IM5",interrupters[5],"RAID")
end

function InterruptManager_InterrupterDied(destName)
    tremove(interrupters,destName)
    for i = 1,#interrupters do
        local j
        if interrupters[i] == destName then
            if interrupters[j] then
                interrupters[i] = interrupters[j]
            end
        end
    end
end

function InterruptManager_OnUpdate(self, elapsed)
    for i=1,5 do
        if cooldowns1[i] and cooldowns2[i] then
            getglobal("IMBar"..i):SetValue(cooldowns1[i] + cooldowns2[i] - GetTime())
            getglobal("IMBar"..i):SetStatusBarColor((cooldowns1[i] - GetTime()) / cooldowns2[i] + 1,1,0)
        end
    end
    if GetTime() >= CPUSafe then
        CPUSafe = GetTime() + 0.5
        if GetTime() >= lastExpirant then
            InterruptManager:SetScript("OnUpdate",nil)
            print("Disabled")
            else
        end
    end
end

function Test()
end

function Test2()
    Test3(5,1)
end

function CD(duration, num)
    cooldowns1[num] = GetTime()
    cooldowns2[num] = duration
    if not lastExpirant or cooldowns1[num] + cooldowns2[num] > lastExpirant then
        lastExpirant = cooldowns1[num] + cooldowns2[num]
    end
    InterruptManager:SetScript("OnUpdate",InterruptManager_OnUpdate)
end